import nl4py
import logging
import pytest
import sys
import time

logger = logging.getLogger('suite_network')

def test_regular_lattice_side(setup_model):
    logger.debug("Regular-lattice-side^2 agents were generated")
    setup_model.workspace.command("set regular-lattice-side 9")
    setup_model.workspace.command("setup-regular-lattice")
    time.sleep(.500)
    value = setup_model.workspace.report("count turtles")
    time.sleep(.500)
    assert value == 81

def test_num_nodes(setup_model):
    logger.debug("Num-nodes is used to set number of turtles")
    setup_model.workspace.command("set num-nodes 83")
    setup_model.workspace.command("setup-barabasi-albert")
    time.sleep(.500)
    turtles = setup_model.workspace.report("count turtles")
    assert turtles == 83

def test_wiring_probability(setup_model):
    logger.debug("With higher wiring-prob, node degree of turtles is higher")
    setup_model.workspace.command("set wiring-prob 0.1")
    setup_model.workspace.command("setup-erdos-renyi")
    time.sleep(.500)
    node_degree_lower_prob = setup_model.workspace.report("mean [count link-neighbors] of turtles") #node degree = number of connections it has to other nodes
    setup_model.workspace.command("set wiring-prob 0.8")
    setup_model.workspace.command("setup-erdos-renyi")
    time.sleep(.500)
    node_degree_higher_prob = setup_model.workspace.report("mean [count link-neighbors] of turtles")
    assert node_degree_lower_prob < node_degree_higher_prob
