import logging
import sys
import time

import nl4py

logger = logging.getLogger('utils')

class NLServer:

    def __init__(self):
        self.workspace = None

    def start_server(self):
        logger.info('Starting NL server')
        nl4py.startServer("/home/martina/Stažené/NetLogo_6.1.1/")
        time.sleep(3)

    def new_workspace(self):
        nl4py.deleteAllHeadlessWorkspaces()
        time.sleep(1)
        self.workspace = nl4py.netlogoWorkspaceFactory.newNetLogoHeadlessWorkspace()
        time.sleep(3)
        self.workspace.openModel("../PDG-cooperation-simulator/pdg-cooperation-simulator.nlogo")
        time.sleep(3)

    
    def restart_server(self):
        logger.info('Restarting NL server')
        self.stop_server()
        time.sleep(2)
        self.start_server()

    def stop_server(self):
        logger.info('Stopping NL server')
        self.workspace.closeModel()
        time.sleep(3)
        nl4py.stopServer()
        time.sleep(2)
